/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.core;

import org.bukkit.entity.Player;
import org.bukkit.util.Vector;

public interface WorldEditRendererWrapper {
    WorldEditRendererWrapper fallback = VersionDependent.getVersionImpl(Core.getInstance(), 9);
    WorldEditRendererWrapper impl = VersionDependent.getVersionImpl(Core.getInstance());

    static void safeDraw(Player player, boolean scheduled, boolean clipboard, Vector pos1, Vector pos2) {
        if (PlayerVersion.isBedrock(player) || PlayerVersion.getVersion(player) < 20) {
            fallback.draw(player, scheduled, clipboard, pos1, pos2);
        } else {
            impl.draw(player, scheduled, clipboard, pos1, pos2);
        }
    }

    void draw(Player player, boolean scheduled, boolean clipboard, Vector pos1, Vector pos2);

    void tick(Player player);

    void hide(Player player, boolean clipboard, boolean hide);

    void remove(Player player);
}
